	section base64

	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_sbasic'
	include 'dev8_mac_proc'

	xref	ut_gxlin
	xref	ut_rtfd1

b64_initp
	lea	b64_procs,a1
	move.w	sb.inipr,a2
	jmp	(a2)

b64_procs
	proc_stt
	proc_end
	proc_stt
	proc_ref B64_ENCODE
	proc_ref B64_DECODE
	proc_end

b64_exit
	rts

;+++
; output_size = B64_ENCODE source-addr, length, dest-addr
;---
b64_encode
	moveq	#$18,d0 	; check for exactly 3 parameters
	jsr	ut_gxlin
	bne	b64_exit

	move.l	(a6,a1.l),a0	; source
	move.l	4(a6,a1.l),d1	; length
	move.l	8(a6,a1.l),a2	; dest

	moveq	#0,d2		; columns
	lea	e64_tab,a3	; translation table

;	d1 = length
;	d2 = column
;	a0 = input buffer
;	a2 = output buffer
;	a3 = b64_tab

tb_encloop
	cmp.w	#71,d2
	bcs.s	tb_nonewline
	move.b	#10,(a2)+
	moveq	#0,d2
tb_nonewline
	tst.l	d1
	beq.s	tb_end		; we're done
	subq.l	#3,d1		; padding needed?
	bcs.s	tb_pad		; yes

	move.l	(a0),d3 	; get long and chop of lowest byte
	lsr.l	#8,d3
	adda.w	#3,a0		; okay, got 3
	moveq	#3,d7
tb_loop
	moveq	#63,d4
	and.b	d3,d4
	move.b	(a3,d4.w),d5	; translate
	ror.l	#8,d5		; next destination byte place
	lsr.l	#6,d3		; next 6 source bits
	dbf	d7,tb_loop

	move.l	d5,(a2)+	; save in output buffer
	addq.l	#4,d2
	bra.s	tb_encloop

; d1 = -2 (2 pads) or -1 (one pad)
tb_pad
	moveq	#0,d3
	cmp.w	#-2,d1
	bne.s	tb_pad1
	move.b	(a0),d3
	lsr.b	#2,d3		; first 6 bits
	move.b	(a3,d3.w),(a2)+ ; translate
	move.b	(a0),d3
	lsl.b	#6,d3		; remaining 2 bits
	move.b	(a3,d3.w),(a2)+ ; translate
	move.w	#'==',(a2)+	; pad
	bra.s	tb_padend

tb_pad1
	move.b	(a0),d3
	lsr.b	#2,d3		; first 6 bits
	move.b	(a3,d3.w),(a2)+
	move.w	#$03f0,d3	; remaining 2 bits and 4 more bits
	and.w	(a0),d3
	lsr.w	#4,d3
	move.b	(a3,d3.w),(a2)+
	moveq	#$f,d3
	and.w	(a0),d3 	; remaining 4 bits
	lsl.w	#2,d3		; pad to 6 bits
	move.b	(a3,d3.w),(a2)+
	move.b	#'=',(a2)+	; single pad
tb_padend
	addq.w	#4,d2
tb_end
	tst.w	d2
	beq.s	tb_rts
	move.b	#10,(a2)+
tb_rts
	move.l	a2,d1
	sub.l	8(a6,a1.l),d1	; calculate size of output buffer
	adda.w	#12,a1		; remove parameters from stack
	move.l	a1,sb_arthp(a6)
	jmp	ut_rtfd1	; return float

e64_tab dc.b	'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
	dc.b	'abcdefghijklmnopqrstuvwxyz'
	dc.b	'0123456789+/'

ws	equ	88		; white space
pd	equ	99		; padding

d64_tab dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,ws,-1,-1,ws,-1,-1 ; 0
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 16
	dc.b	ws,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,63,-1,-1,-1,62 ; 32
	dc.b	52,53,54,55,56,57,58,59,60,61,-1,-1,-1,pd,-1,-1 ; 48
	dc.b	-1,00,01,02,03,04,05,06,07,08,09,10,11,12,13,14 ; 64
	dc.b	15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1 ; 80
	dc.b	00,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40 ; 96
	dc.b	41,42,43,44,45,46,47,48,49,50,51,-1,-1,-1,-1,-1 ; 112
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 128
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 144
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 160
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 176
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 192
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 208
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 224
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 ; 240

;+++
; output_size = B64_DECODE source-addr, length, dest-addr
;---
b64_decode
	moveq	#$18,d0 	; check for exactly 3 parameters
	jsr	ut_gxlin
	bne	b64_exit

	move.l	(a6,a1.l),a0	; source
	move.l	4(a6,a1.l),d1	; length
	move.l	8(a6,a1.l),a2	; dest

	lea	d64_tab,a3	; translation table

	moveq	#0,d0		; just clear upper bits
	moveq	#0,d2		; ouput length counter
d64_loop
	moveq	#0,d3		; hold decoded bytes
	moveq	#4,d4		; 4 encoded bytes per 3 decoded bytes
	moveq	#0,d5		; bit counter
d64_innerloop
	subq.l	#1,d1		; one less byte in input buffer
	beq.s	d64_exit	; premature end!

	move.b	(a0)+,d0
	move.b	(a3,d0.w),d0
	bmi.s	d64_exit	; invalid character encountered
	cmpi.b	#ws,d0		; characters like LF?
	beq.s	d64_innerloop	; ignore

	asl.l	#6,d3
	cmpi.b	#pd,d0		; padding flag?
	beq.s	d64_trail	; yes
	or.b	d0,d3
	addq.l	#6,d5
d64_trail
	subq.l	#1,d4
	bne.s	d64_innerloop

	lsr.l	#3,d5
	add.l	d5,d2		; output length

	rol.l	#8,d3
	move.l	d5,d4
	beq.s	d64_exit
d64_copy
	rol.l	#8,d3
	move.b	d3,(a2)+
	subq.l	#1,d4
	bne.s	d64_copy

	cmpi.b	#3,d5
	beq.s	d64_loop

d64_exit
	move.l	d2,d1		; output length
	adda.w	#12,a1		; remove parameters from stack
	move.l	a1,sb_arthp(a6)
	jmp	ut_rtfd1	; return float


	end
